unit UnitDataModule;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DB, DBTables;

type
  TDataModule2 = class(TDataModule)
    Database1: TDatabase;
    DataSource1: TDataSource;
    Table1: TTable;
    StoredProcGetBudgetInfo: TStoredProc;
    Table1CUST_NO: TIntegerField;
    Table1CUSTOMER: TStringField;
    Table1CONTACT_FIRST: TStringField;
    Table1CONTACT_LAST: TStringField;
    Table1PHONE_NO: TStringField;
    Table1ADDRESS_LINE1: TStringField;
    Table1ADDRESS_LINE2: TStringField;
    Table1CITY: TStringField;
    Table1STATE_PROVINCE: TStringField;
    Table1COUNTRY: TStringField;
    Table1POSTAL_CODE: TStringField;
    Table1ON_HOLD: TStringField;
    procedure DataModule2Create(Sender: TObject);
    procedure Database1Login(Database: TDatabase; LoginParams: TStrings);
    procedure DataSource1StateChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DataModule2: TDataModule2;

function GetNetUserName: String;

implementation

uses DBIProcs, DBIErrs, DBITypes, UnitMainForm, UnitStartTwoThreads;

{$R *.DFM}

function GetNetUserName: String;
begin
   SetLength(Result, dbiMaxUserNameLen + 1);
   // Get network user name and call Check to generate an exection if an error
   Check(DbiGetNetUserName(PChar(Result)));
   SetLength(Result, StrLen(PChar(Result)));
end;


procedure TDataModule2.DataModule2Create(Sender: TObject);
begin
   // Maintain temporary database connections
   Session.KeepConnections := False;
   if Database1.KeepConnection = False then showmessage('False');
   StoredProcGetBudgetInfo.Prepare;
end;

procedure TDataModule2.Database1Login(Database: TDatabase;
  LoginParams: TStrings);
begin
     // Provide automatic login if know user
     if GetNetUserName='DAVID' then begin
        LoginParams.Values['USER NAME'] := 'SYSDBA';
        LoginParams.Values['PASSWORD'] := 'masterkey';
     end;
end;

procedure TDataModule2.DataSource1StateChange(Sender: TObject);
var
   State: string;
begin
     Case DataSource1.State of
          dsInactive:       State:= 'Inactive';
          dsBrowse:         State:= 'Browse';
          dsEdit:           State:= 'Edit';
          dsInsert:         State:= 'Insert';
          dsSetKey:         State:= 'SetKey';
          dsCalcFields:     State:= 'CalcFields';
          dsUpdateNew:      State:= 'UpdateNew';
          dsUpdateOld:      State:= 'UpdateOld';
          dsFilter:         State:= 'Filter';
     else
         State:= 'Unknown';
     end;
     if Assigned (frMainForm) then
        frMainForm.laDataSourceState.Caption:='State: '+State;
end;

end.
