unit UnitMainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Grids, DBGrids, DBCtrls, ExtCtrls, StdCtrls, DB;

type
  TfrMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    DBGrid1: TDBGrid;
    OtherOptions1: TMenuItem;
    DisplayNetworkUserName1: TMenuItem;
    Panel1: TPanel;
    DBNavigator1: TDBNavigator;
    laDataSourceState: TLabel;
    GroupBoxTDatabase: TGroupBox;
    buStartTransaction: TButton;
    buCommit: TButton;
    buRollback: TButton;
    StoredProcedureGet1: TMenuItem;
    GroupBox1: TGroupBox;
    ChBxCachedUpdates: TCheckBox;
    BuCancelUpdates: TButton;
    BuApplyUpdates: TButton;
    TwoThreadsForm1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure DisplayNetworkUserName1Click(Sender: TObject);
    procedure buStartTransactionClick(Sender: TObject);
    procedure buRollbackClick(Sender: TObject);
    procedure buCommitClick(Sender: TObject);
    procedure ChBxCachedUpdatesClick(Sender: TObject);
    procedure BuCancelUpdatesClick(Sender: TObject);
    procedure BuApplyUpdatesClick(Sender: TObject);
    procedure StoredProcedureGet1Click(Sender: TObject);
    procedure TwoThreadsForm1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frMainForm: TfrMainForm;

implementation

uses UnitDataModule, UnitThreads, UnitStartTwoThreads;

{$R *.DFM}

procedure TfrMainForm.FormCreate(Sender: TObject);
begin
     buRollback.Enabled:= False;
     buCommit.Enabled:=   False;
     DataModule2.DataSource1StateChange(Sender);
     Panel1.Caption:=     '';
     Panel1.BevelInner:=  bvNone;
     Panel1.BevelOuter:=  bvNone;
end;

procedure TfrMainForm.DisplayNetworkUserName1Click(Sender: TObject);
var
   fUserName: string;
begin
     fUserName:= GetNetUserName;
     if fUserName = '' then
        MessageDlg('No user name available.', mtInformation, [mbOk], 0)
     else
         MessageDlg('User name is '+ fUserName, mtInformation, [mbOk], 0);
end;

procedure TfrMainForm.buStartTransactionClick(Sender: TObject);
begin
     DataModule2.Database1.StartTransaction;
     buStartTransaction.Enabled:= False;
     buRollback.Enabled:= True;
     buCommit.Enabled:=   True;
end;

procedure TfrMainForm.buCommitClick(Sender: TObject);
begin
     if DataModule2.DataSource1.State in [dsEdit,dsInsert] then
        DataModule2.Table1.Post;
     DataModule2.Database1.Commit;
     buStartTransaction.Enabled:= True;
     buRollback.Enabled:= False;
     buCommit.Enabled:=   False;
end;

procedure TfrMainForm.buRollbackClick(Sender: TObject);
begin
     if DataModule2.DataSource1.State in [dsEdit,dsInsert] then
        DataModule2.Table1.Cancel;
     DataModule2.DataBase1.Rollback;
     buStartTransaction.Enabled:= True;
     buRollback.Enabled:= False;
     buCommit.Enabled:=   False;
end;

procedure TfrMainForm.ChBxCachedUpdatesClick(Sender: TObject);
begin
     DataModule2.Table1.CachedUpdates:= ChBxCachedUpdates.Checked;
     BuCancelUpdates.Enabled:=          ChBxCachedUpdates.Checked;
     BuApplyUpdates.Enabled:=           ChBxCachedUpdates.Checked;
end;

procedure TfrMainForm.BuCancelUpdatesClick(Sender: TObject);
begin
     DataModule2.Table1.CancelUpdates;
end;

procedure TfrMainForm.BuApplyUpdatesClick(Sender: TObject);
begin
     DataModule2.Table1.ApplyUpdates;
end;

procedure TfrMainForm.StoredProcedureGet1Click(Sender: TObject);
var
   Total_Budget: real;
begin
     DataModule2.StoredProcGetBudgetInfo.ExecProc;
     Total_Budget:=  DataModule2.StoredProcGetBudgetInfo.Params.ParamByName('tot_budget').AsFloat;
     MessageDlg ('Total_Budget ' + FloatToStr(Total_Budget),
                mtInformation, [mbOK], 0);
end;

procedure TfrMainForm.TwoThreadsForm1Click(Sender: TObject);
begin
     FrTwoThreads:= TFrTwoThreads.Create(nil);
     try
        FrTwoThreads.ShowModal;
     finally
            FrTwoThreads.Free;
     end;
end;

end.
