type
  TMyUpgrader = class(TxUpgrader)
  public
    function Upgrade(aVersion: Integer): Integer; override;
  end;

function TMyUpgrader.Upgrade(aVersion: Integer): Integer;

  procedure Log(const aVersion: String);
  var
    fLog : TextFile;
  begin
    AssignFile(fLog,ChangeFileExt(ParamStr(0),'.log'));
    try
      try
        Append(fLog);
      except
        Rewrite(fLog);
      end;
      writeln(fLog,'Upgrade to Version ',aVersion,'  at ',DateTimeToStr(Now));
    finally
      CloseFile(fLog);
    end;
  end;

begin
  Result := inherited Upgrade(aVersion);
  if aVersion < 110 then
  begin
    { Here we do upgrade to Version 1.10 }
    Log('1.10');
    Result := 110;
  end else if aVersion < 120 then
  begin
    { Here we do upgrade to Version 1.20 }
    Log('1.20');
    Result := 120;
  end else
    Log('<none>');
end;
